/*
 * File: FanControl.c
 *
 * Code generated for Simulink model 'FanControl'.
 *
 * Model version                  : 1.113
 * Simulink Coder version         : 8.6 (R2014a) 27-Dec-2013
 * TLC version                    : 8.6 (Jan 30 2014)
 * C/C++ source code generated on : Thu Mar 26 12:50:54 2015
 *
 * Target selection: realtime.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "FanControl.h"
#include "FanControl_private.h"

/* Block signals (auto storage) */
B_FanControl_T FanControl_B;

/* Block states (auto storage) */
DW_FanControl_T FanControl_DW;

/* Previous zero-crossings (trigger) states */
PrevZCX_FanControl_T FanControl_PrevZCX;

/* Real-time model */
RT_MODEL_FanControl_T FanControl_M_;
RT_MODEL_FanControl_T *const FanControl_M = &FanControl_M_;
static void rate_scheduler(void);

/*
 *   This function updates active task flag for each subrate.
 * The function is called at model base rate, hence the
 * generated code self-manages all its subrates.
 */
static void rate_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (FanControl_M->Timing.TaskCounters.TID[2])++;
  if ((FanControl_M->Timing.TaskCounters.TID[2]) > 9) {/* Sample time: [0.001s, 0.0s] */
    FanControl_M->Timing.TaskCounters.TID[2] = 0;
  }

  (FanControl_M->Timing.TaskCounters.TID[3])++;
  if ((FanControl_M->Timing.TaskCounters.TID[3]) > 99) {/* Sample time: [0.01s, 0.0s] */
    FanControl_M->Timing.TaskCounters.TID[3] = 0;
  }

  (FanControl_M->Timing.TaskCounters.TID[4])++;
  if ((FanControl_M->Timing.TaskCounters.TID[4]) > 999) {/* Sample time: [0.1s, 0.0s] */
    FanControl_M->Timing.TaskCounters.TID[4] = 0;
  }

  (FanControl_M->Timing.TaskCounters.TID[5])++;
  if ((FanControl_M->Timing.TaskCounters.TID[5]) > 9999) {/* Sample time: [1.0s, 0.0s] */
    FanControl_M->Timing.TaskCounters.TID[5] = 0;
  }
}

uint32_T MWDSP_EPH_R_B(boolean_T evt, uint32_T *sta)
{
  uint32_T retVal;
  int16_T curState;
  int16_T newState;
  int16_T newStateR;
  int16_T lastzcevent;
  uint32_T previousState;

  /* S-Function (sdspcount2): '<S16>/Counter' */
  /* Detect rising edge events */
  previousState = *sta;
  retVal = 0UL;
  lastzcevent = 0;
  newState = 5;
  newStateR = 5;
  if (evt) {
    curState = 2;
  } else {
    curState = 1;
  }

  if (*sta == 5UL) {
    newStateR = curState;
  } else {
    if ((uint32_T)curState != *sta) {
      if (*sta == 3UL) {
        if ((uint16_T)curState == 1U) {
          newStateR = 1;
        } else {
          lastzcevent = 2;
          previousState = 1UL;
        }
      }

      if (previousState == 4UL) {
        if ((uint16_T)curState == 1U) {
          newStateR = 1;
        } else {
          lastzcevent = 3;
          previousState = 1UL;
        }
      }

      if ((previousState == 1UL) && ((uint16_T)curState == 2U)) {
        retVal = 2UL;
      }

      if (previousState == 0UL) {
        retVal = 2UL;
      }

      if ((uint16_T)retVal == (uint16_T)lastzcevent) {
        retVal = 0UL;
      }

      if (((uint16_T)curState == 1U) && ((uint16_T)retVal == 2U)) {
        newState = 3;
      } else {
        newState = curState;
      }
    }
  }

  if ((uint16_T)newStateR != 5U) {
    *sta = (uint32_T)newStateR;
    retVal = 0UL;
  }

  if ((uint16_T)newState != 5U) {
    *sta = (uint32_T)newState;
  }

  /* End of S-Function (sdspcount2): '<S16>/Counter' */
  return retVal;
}

real_T rt_roundd_snf(real_T u)
{
  real_T y;
  if (fabs(u) < 4.503599627370496E+15) {
    if (u >= 0.5) {
      y = floor(u + 0.5);
    } else if (u > -0.5) {
      y = u * 0.0;
    } else {
      y = ceil(u - 0.5);
    }
  } else {
    y = u;
  }

  return y;
}

real_T rt_remd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T u1_0;
  if (!((!rtIsNaN(u0)) && (!rtIsInf(u0)) && ((!rtIsNaN(u1)) && (!rtIsInf(u1)))))
  {
    y = (rtNaN);
  } else {
    if (u1 < 0.0) {
      u1_0 = ceil(u1);
    } else {
      u1_0 = floor(u1);
    }

    if ((u1 != 0.0) && (u1 != u1_0)) {
      u1_0 = u0 / u1;
      if (fabs(u1_0 - rt_roundd_snf(u1_0)) <= DBL_EPSILON * fabs(u1_0)) {
        y = 0.0;
      } else {
        y = fmod(u0, u1);
      }
    } else {
      y = fmod(u0, u1);
    }
  }

  return y;
}

/* Model output function */
void FanControl_output(void)
{
  /* local block i/o variables */
  real_T rtb_Gain2;
  uint8_T b_serPin;
  uint8_T b_sckPin;
  uint8_T b_rckPin;
  real_T rtb_ProportionalGain;
  boolean_T rtb_FixPtRelationalOperator;
  real_T rtb_ProportionalGain_c;
  ZCEventType zcEvent;
  uint16_T rtb_Counter;
  uint8_T rtb_Add;
  uint8_T tmp[8];
  if (FanControl_M->Timing.TaskCounters.TID[3] == 0) {
    /* S-Function (arduinoanaloginput_sfcn): '<Root>/Analog Input1' */
    FanControl_B.AnalogInput1 = MW_analogRead(FanControl_P.AnalogInput1_p1);
  }

  if (FanControl_M->Timing.TaskCounters.TID[4] == 0) {
    /* S-Function (arduinoanaloginput_sfcn): '<Root>/Analog Input' */
    FanControl_B.AnalogInput = MW_analogRead(FanControl_P.AnalogInput_p1);
  }

  if (FanControl_M->Timing.TaskCounters.TID[3] == 0) {
    /* Switch: '<S8>/Switch2' incorporates:
     *  Constant: '<S8>/fanswitch'
     *  Sum: '<S8>/Sum3'
     */
    if (FanControl_B.AnalogInput1 - FanControl_B.AnalogInput >
        FanControl_P.Switch2_Threshold) {
      rtb_Gain2 = FanControl_B.AnalogInput1;
    } else {
      rtb_Gain2 = FanControl_P.T_des;
    }

    /* End of Switch: '<S8>/Switch2' */

    /* Sum: '<S8>/Sum' incorporates:
     *  Constant: '<Root>/T_des'
     */
    rtb_Gain2 -= FanControl_P.T_des;

    /* Gain: '<S25>/Proportional Gain' */
    rtb_ProportionalGain = FanControl_P.TempPIcontroller_P_Gain * rtb_Gain2;

    /* Switch: '<S25>/Switch1' incorporates:
     *  Constant: '<S25>/intswitch'
     *  Constant: '<S26>/Constant'
     *  Constant: '<S27>/Constant'
     *  Logic: '<S25>/Logical Operator'
     *  RelationalOperator: '<S26>/Compare'
     *  RelationalOperator: '<S27>/Compare'
     *  UnitDelay: '<S8>/Unit Delay'
     */
    if ((FanControl_DW.UnitDelay_DSTATE <= FanControl_P.CompareToConstant_const)
        || (FanControl_DW.UnitDelay_DSTATE >=
            FanControl_P.CompareToConstant1_const)) {
      rtb_Gain2 = FanControl_P.intswitch_Value;
    }

    /* End of Switch: '<S25>/Switch1' */

    /* Gain: '<S25>/Integral Gain' */
    FanControl_B.IntegralGain = FanControl_P.TempPIcontroller_I_Gain *
      FanControl_P.T / 2.0 * rtb_Gain2;

    /* DiscreteZeroPole: '<S25>/Discrete Zero-Pole' */
    {
      rtb_Gain2 = FanControl_P.DiscreteZeroPole_D*FanControl_B.IntegralGain;
      rtb_Gain2 += FanControl_P.DiscreteZeroPole_C*
        FanControl_DW.DiscreteZeroPole_DSTATE;
    }

    /* Gain: '<S8>/Gain2' incorporates:
     *  Sum: '<S25>/Sum1'
     */
    rtb_Gain2 = (rtb_ProportionalGain + rtb_Gain2) * FanControl_P.Gain2_Gain;

    /* Saturate: '<S8>/Saturation' */
    if (rtb_Gain2 > FanControl_P.Saturation_UpperSat) {
      rtb_ProportionalGain = FanControl_P.Saturation_UpperSat;
    } else if (rtb_Gain2 < FanControl_P.Saturation_LowerSat) {
      rtb_ProportionalGain = FanControl_P.Saturation_LowerSat;
    } else {
      rtb_ProportionalGain = rtb_Gain2;
    }

    /* Sum: '<S8>/Sum4' incorporates:
     *  Constant: '<S8>/n_offset'
     *  Saturate: '<S8>/Saturation'
     */
    FanControl_B.n_stell = rtb_ProportionalGain + FanControl_P.n_offset_Value;
  }

  /* S-Function (arduinodigitalinput_sfcn): '<S6>/Digital Input1' */
  rtb_FixPtRelationalOperator = MW_digitalRead(FanControl_P.DigitalInput1_p1);

  /* RelationalOperator: '<S24>/Compare' incorporates:
   *  Constant: '<S24>/Constant'
   *  S-Function (arduinodigitalinput_sfcn): '<S6>/Digital Input1'
   */
  FanControl_B.Compare = ((int16_T)rtb_FixPtRelationalOperator > (int16_T)
    FanControl_P.Constant_Value_h);

  /* RelationalOperator: '<S19>/FixPt Relational Operator' incorporates:
   *  UnitDelay: '<S19>/Delay Input1'
   */
  rtb_FixPtRelationalOperator = ((int16_T)FanControl_B.Compare > (int16_T)
    FanControl_DW.DelayInput1_DSTATE);
  if (FanControl_M->Timing.TaskCounters.TID[2] == 0) {
    /* UnitDelay: '<S17>/Output' */
    FanControl_B.Output = FanControl_DW.Output_DSTATE;
  }

  /* RelationalOperator: '<S18>/Compare' incorporates:
   *  Constant: '<S18>/Constant'
   */
  FanControl_B.Compare_j = (FanControl_B.Output == FanControl_P.ResetValue_const);

  /* S-Function (sdspcount2): '<S16>/Counter' */
  if (MWDSP_EPH_R_B(FanControl_B.Compare_j, &FanControl_DW.Counter_RstEphState)
      != 0UL) {
    FanControl_DW.Counter_Count = FanControl_P.Counter_InitialCount;
  }

  if (MWDSP_EPH_R_B(rtb_FixPtRelationalOperator,
                    &FanControl_DW.Counter_ClkEphState) != 0UL) {
    if (FanControl_DW.Counter_Count < 60000U) {
      FanControl_DW.Counter_Count++;
    } else {
      FanControl_DW.Counter_Count = 0U;
    }
  }

  /* RelationalOperator: '<S21>/Compare' incorporates:
   *  Constant: '<S21>/Constant'
   */
  rtb_FixPtRelationalOperator = (FanControl_B.Output ==
    FanControl_P.SampleandHoldValue_const);

  /* Outputs for Triggered SubSystem: '<S16>/Sample and Hold' incorporates:
   *  TriggerPort: '<S20>/Trigger'
   */
  if (rtb_FixPtRelationalOperator && (FanControl_PrevZCX.SampleandHold_Trig_ZCE
       != POS_ZCSIG)) {
    /* Inport: '<S20>/In' incorporates:
     *  S-Function (sdspcount2): '<S16>/Counter'
     */
    FanControl_B.In = FanControl_DW.Counter_Count;
  }

  FanControl_PrevZCX.SampleandHold_Trig_ZCE = (uint8_T)
    (rtb_FixPtRelationalOperator ? (int16_T)POS_ZCSIG : (int16_T)ZERO_ZCSIG);

  /* End of Outputs for SubSystem: '<S16>/Sample and Hold' */

  /* DataTypeConversion: '<S16>/Data Type Conversion' incorporates:
   *  Gain: '<S16>/Gain'
   */
  FanControl_B.DataTypeConversion = (real_T)((uint32_T)FanControl_P.Gain_Gain_n *
    FanControl_B.In) * 0.00048828125;
  if (FanControl_M->Timing.TaskCounters.TID[2] == 0) {
    /* Sum: '<S6>/Sum2' */
    rtb_ProportionalGain = FanControl_B.n_stell -
      FanControl_B.DataTypeConversion;

    /* Gain: '<S15>/Proportional Gain' */
    rtb_ProportionalGain_c = FanControl_P.RPMPIcontroller_P_Gain *
      rtb_ProportionalGain;

    /* Gain: '<S15>/Integral Gain' */
    FanControl_B.IntegralGain_d = FanControl_P.RPMPIcontroller_I_Gain *
      FanControl_P.T / 2.0 * rtb_ProportionalGain;
  }

  if (FanControl_M->Timing.TaskCounters.TID[3] == 0) {
    /* DiscreteZeroPole: '<S15>/Discrete Zero-Pole' */
    {
      FanControl_B.DiscreteZeroPole = FanControl_P.DiscreteZeroPole_D_l*
        FanControl_B.IntegralGain_d;
      FanControl_B.DiscreteZeroPole += FanControl_P.DiscreteZeroPole_C_a*
        FanControl_DW.DiscreteZeroPole_DSTATE_e;
    }
  }

  if (FanControl_M->Timing.TaskCounters.TID[2] == 0) {
    /* Gain: '<S14>/Gain' incorporates:
     *  Sum: '<S15>/Sum1'
     */
    rtb_ProportionalGain = (rtb_ProportionalGain_c +
      FanControl_B.DiscreteZeroPole) * FanControl_P.Gain_Gain;

    /* Saturate: '<S14>/Saturation' */
    if (rtb_ProportionalGain > FanControl_P.Saturation_UpperSat_h) {
      /* DataTypeConversion: '<S4>/Data Type Conversion' */
      rtb_ProportionalGain = FanControl_P.Saturation_UpperSat_h;
    } else {
      if (rtb_ProportionalGain < FanControl_P.Saturation_LowerSat_f) {
        /* DataTypeConversion: '<S4>/Data Type Conversion' */
        rtb_ProportionalGain = FanControl_P.Saturation_LowerSat_f;
      }
    }

    /* End of Saturate: '<S14>/Saturation' */

    /* DataTypeConversion: '<S4>/Data Type Conversion' */
    if (rtb_ProportionalGain < 256.0) {
      if (rtb_ProportionalGain >= 0.0) {
        rtb_Add = (uint8_T)rtb_ProportionalGain;
      } else {
        rtb_Add = 0U;
      }
    } else {
      rtb_Add = MAX_uint8_T;
    }

    /* S-Function (arduinoanalogoutput_sfcn): '<S4>/PWM' */
    MW_analogWrite(FanControl_P.PWM_pinNumber, rtb_Add);
  }

  if (FanControl_M->Timing.TaskCounters.TID[5] == 0) {
    /* DataTypeConversion: '<S7>/Data Type Conversion1' incorporates:
     *  Constant: '<S7>/SOF1'
     */
    rtb_ProportionalGain = floor(FanControl_P.SOF1_Value);
    if (rtIsNaN(rtb_ProportionalGain) || rtIsInf(rtb_ProportionalGain)) {
      rtb_ProportionalGain = 0.0;
    } else {
      rtb_ProportionalGain = fmod(rtb_ProportionalGain, 256.0);
    }

    /* S-Function (arduinoserialwrite_sfcn): '<S7>/Serial Transmit' incorporates:
     *  DataTypeConversion: '<S7>/Data Type Conversion1'
     */
    tmp[0] = (uint8_T)(rtb_ProportionalGain < 0.0 ? (int16_T)(uint8_T)-(int8_T)
                       (uint8_T)-rtb_ProportionalGain : (int16_T)(uint8_T)
                       rtb_ProportionalGain);

    /* DataTypeConversion: '<S7>/Data Type Conversion2' incorporates:
     *  Constant: '<S7>/SOF2'
     */
    rtb_ProportionalGain = floor(FanControl_P.SOF2_Value);
    if (rtIsNaN(rtb_ProportionalGain) || rtIsInf(rtb_ProportionalGain)) {
      rtb_ProportionalGain = 0.0;
    } else {
      rtb_ProportionalGain = fmod(rtb_ProportionalGain, 256.0);
    }

    /* S-Function (arduinoserialwrite_sfcn): '<S7>/Serial Transmit' incorporates:
     *  DataTypeConversion: '<S7>/Data Type Conversion2'
     *  DataTypeConversion: '<S7>/Data Type Conversion3'
     *  DataTypeConversion: '<S7>/Data Type Conversion4'
     *  SignalConversion: '<S7>/TmpSignal ConversionAtSerial TransmitInport1'
     */
    tmp[1] = (uint8_T)(rtb_ProportionalGain < 0.0 ? (int16_T)(uint8_T)-(int8_T)
                       (uint8_T)-rtb_ProportionalGain : (int16_T)(uint8_T)
                       rtb_ProportionalGain);
    tmp[2] = (uint8_T)FanControl_B.AnalogInput;
    tmp[3] = (uint8_T)FanControl_B.AnalogInput1;

    /* DataTypeConversion: '<S7>/Data Type Conversion5' incorporates:
     *  Constant: '<S7>/Constant'
     *  Product: '<S7>/Divide'
     */
    rtb_ProportionalGain = floor(FanControl_B.DataTypeConversion /
      FanControl_P.Constant_Value);
    if (rtIsNaN(rtb_ProportionalGain) || rtIsInf(rtb_ProportionalGain)) {
      rtb_ProportionalGain = 0.0;
    } else {
      rtb_ProportionalGain = fmod(rtb_ProportionalGain, 256.0);
    }

    /* S-Function (arduinoserialwrite_sfcn): '<S7>/Serial Transmit' incorporates:
     *  DataTypeConversion: '<S7>/Data Type Conversion5'
     *  SignalConversion: '<S7>/TmpSignal ConversionAtSerial TransmitInport1'
     */
    tmp[4] = (uint8_T)(rtb_ProportionalGain < 0.0 ? (int16_T)(uint8_T)-(int8_T)
                       (uint8_T)-rtb_ProportionalGain : (int16_T)(uint8_T)
                       rtb_ProportionalGain);

    /* DataTypeConversion: '<S7>/Data Type Conversion6' incorporates:
     *  Constant: '<S7>/Constant'
     *  Math: '<S7>/Math Function'
     */
    rtb_ProportionalGain = floor(rt_remd_snf(FanControl_B.DataTypeConversion,
      FanControl_P.Constant_Value));
    if (rtIsNaN(rtb_ProportionalGain) || rtIsInf(rtb_ProportionalGain)) {
      rtb_ProportionalGain = 0.0;
    } else {
      rtb_ProportionalGain = fmod(rtb_ProportionalGain, 256.0);
    }

    /* S-Function (arduinoserialwrite_sfcn): '<S7>/Serial Transmit' incorporates:
     *  DataTypeConversion: '<S7>/Data Type Conversion6'
     *  SignalConversion: '<S7>/TmpSignal ConversionAtSerial TransmitInport1'
     */
    tmp[5] = (uint8_T)(rtb_ProportionalGain < 0.0 ? (int16_T)(uint8_T)-(int8_T)
                       (uint8_T)-rtb_ProportionalGain : (int16_T)(uint8_T)
                       rtb_ProportionalGain);

    /* DataTypeConversion: '<S7>/Data Type Conversion7' incorporates:
     *  Constant: '<S7>/EOF1'
     */
    rtb_ProportionalGain = floor(FanControl_P.EOF1_Value);
    if (rtIsNaN(rtb_ProportionalGain) || rtIsInf(rtb_ProportionalGain)) {
      rtb_ProportionalGain = 0.0;
    } else {
      rtb_ProportionalGain = fmod(rtb_ProportionalGain, 256.0);
    }

    /* S-Function (arduinoserialwrite_sfcn): '<S7>/Serial Transmit' incorporates:
     *  DataTypeConversion: '<S7>/Data Type Conversion7'
     *  SignalConversion: '<S7>/TmpSignal ConversionAtSerial TransmitInport1'
     */
    tmp[6] = (uint8_T)(rtb_ProportionalGain < 0.0 ? (int16_T)(uint8_T)-(int8_T)
                       (uint8_T)-rtb_ProportionalGain : (int16_T)(uint8_T)
                       rtb_ProportionalGain);

    /* DataTypeConversion: '<S7>/Data Type Conversion8' incorporates:
     *  Constant: '<S7>/EOF2'
     */
    rtb_ProportionalGain = floor(FanControl_P.EOF2_Value);
    if (rtIsNaN(rtb_ProportionalGain) || rtIsInf(rtb_ProportionalGain)) {
      rtb_ProportionalGain = 0.0;
    } else {
      rtb_ProportionalGain = fmod(rtb_ProportionalGain, 256.0);
    }

    /* S-Function (arduinoserialwrite_sfcn): '<S7>/Serial Transmit' incorporates:
     *  DataTypeConversion: '<S7>/Data Type Conversion8'
     *  SignalConversion: '<S7>/TmpSignal ConversionAtSerial TransmitInport1'
     */
    tmp[7] = (uint8_T)(rtb_ProportionalGain < 0.0 ? (int16_T)(uint8_T)-(int8_T)
                       (uint8_T)-rtb_ProportionalGain : (int16_T)(uint8_T)
                       rtb_ProportionalGain);
    Serial_write(FanControl_P.SerialTransmit_portNumber, tmp, 8UL);
  }

  if (FanControl_M->Timing.TaskCounters.TID[2] == 0) {
    /* Sum: '<S22>/FixPt Sum1' incorporates:
     *  Constant: '<S22>/FixPt Constant'
     */
    rtb_Counter = FanControl_B.Output + FanControl_P.FixPtConstant_Value;

    /* Switch: '<S23>/FixPt Switch' incorporates:
     *  Constant: '<S23>/Constant'
     */
    if (rtb_Counter > FanControl_P.CounterLimitedLimit500_uplimit) {
      FanControl_B.FixPtSwitch = FanControl_P.Constant_Value_b;
    } else {
      FanControl_B.FixPtSwitch = rtb_Counter;
    }

    /* End of Switch: '<S23>/FixPt Switch' */
  }

  /* DataTypeConversion: '<S1>/Data Type Conversion' incorporates:
   *  Constant: '<Root>/Heating_status'
   */
  if (FanControl_P.Heating_status_Value < 256.0) {
    if (FanControl_P.Heating_status_Value >= 0.0) {
      rtb_Add = (uint8_T)FanControl_P.Heating_status_Value;
    } else {
      rtb_Add = 0U;
    }
  } else {
    rtb_Add = MAX_uint8_T;
  }

  /* End of DataTypeConversion: '<S1>/Data Type Conversion' */

  /* S-Function (arduinodigitaloutput_sfcn): '<S1>/Digital Output' */
  MW_digitalWrite(FanControl_P.DigitalOutput_pinNumber, rtb_Add);

  /* Sum: '<S9>/Add' incorporates:
   *  Constant: '<S2>/Constant'
   *  Constant: '<S2>/Constant1'
   *  Constant: '<S2>/Constant2'
   *  Constant: '<S2>/Constant3'
   *  Constant: '<S2>/Constant4'
   *  Constant: '<S2>/Constant5'
   *  Constant: '<S2>/Constant6'
   *  Constant: '<S2>/Constant7'
   *  Constant: '<S9>/Constant'
   *  Constant: '<S9>/Constant1'
   *  Constant: '<S9>/Constant2'
   *  Constant: '<S9>/Constant3'
   *  Constant: '<S9>/Constant4'
   *  Constant: '<S9>/Constant5'
   *  Constant: '<S9>/Constant6'
   *  Constant: '<S9>/Constant7'
   *  Product: '<S9>/Product'
   *  Product: '<S9>/Product1'
   *  Product: '<S9>/Product2'
   *  Product: '<S9>/Product3'
   *  Product: '<S9>/Product4'
   *  Product: '<S9>/Product5'
   *  Product: '<S9>/Product6'
   *  Product: '<S9>/Product7'
   */
  rtb_Add = (uint8_T)((((((((uint16_T)FanControl_P.Constant_Value_o *
    FanControl_P.Constant_Value_p + (uint16_T)FanControl_P.Constant1_Value *
    FanControl_P.Constant1_Value_i) + (uint16_T)FanControl_P.Constant2_Value *
    FanControl_P.Constant2_Value_c) + (uint16_T)FanControl_P.Constant3_Value *
    FanControl_P.Constant3_Value_d) + (uint16_T)FanControl_P.Constant4_Value *
    FanControl_P.Constant4_Value_n) + (uint16_T)FanControl_P.Constant5_Value *
                        FanControl_P.Constant5_Value_f) + (uint16_T)
                       FanControl_P.Constant6_Value *
                       FanControl_P.Constant6_Value_k) + (uint16_T)
                      FanControl_P.Constant7_Value *
                      FanControl_P.Constant7_Value_i);

  /* Step: '<S2>/Step' */
  if (FanControl_M->Timing.t[0] < FanControl_P.Step_Time) {
    FanControl_B.Step = FanControl_P.Step_Y0;
  } else {
    FanControl_B.Step = FanControl_P.Step_YFinal;
  }

  /* End of Step: '<S2>/Step' */

  /* MATLAB Function: '<S2>/MATLAB Function' incorporates:
   *  TriggerPort: '<S10>/trigger'
   */
  zcEvent = rt_ZCFcn(RISING_ZERO_CROSSING,
                     &FanControl_PrevZCX.MATLABFunction_Trig_ZCE,
                     (FanControl_B.Step));
  if (zcEvent != NO_ZCEVENT) {
    b_serPin = FanControl_P.MATLABFunction_serPin;
    b_sckPin = FanControl_P.MATLABFunction_sckPin;
    b_rckPin = FanControl_P.MATLABFunction_rckPin;

    /* MATLAB Function 'Fan Settings/MATLAB Function': '<S10>:1' */
    if (!FanControl_DW.initflag_not_empty) {
      /* '<S10>:1:7' */
      /*  initialise output pins and send data to HC595 ic */
      hc595_Init(FanControl_P.MATLABFunction_serPin,
                 FanControl_P.MATLABFunction_sckPin,
                 FanControl_P.MATLABFunction_rckPin,
                 FanControl_P.MATLABFunction_gPin);
      FanControl_DW.initflag_not_empty = true;

      /*  send data to HC595 ic */
      hc595_SendData(rtb_Add, b_serPin, b_sckPin, b_rckPin);
    } else {
      /*  send data to HC595 ic */
      hc595_SendData(rtb_Add, FanControl_P.MATLABFunction_serPin,
                     FanControl_P.MATLABFunction_sckPin,
                     FanControl_P.MATLABFunction_rckPin);
    }
  }
}

/* Model update function */
void FanControl_update(void)
{
  if (FanControl_M->Timing.TaskCounters.TID[3] == 0) {
    /* Update for UnitDelay: '<S8>/Unit Delay' */
    FanControl_DW.UnitDelay_DSTATE = FanControl_B.n_stell;

    /* Update for DiscreteZeroPole: '<S25>/Discrete Zero-Pole' */
    {
      FanControl_DW.DiscreteZeroPole_DSTATE = FanControl_B.IntegralGain +
        FanControl_P.DiscreteZeroPole_A*FanControl_DW.DiscreteZeroPole_DSTATE;
    }
  }

  /* Update for UnitDelay: '<S19>/Delay Input1' */
  FanControl_DW.DelayInput1_DSTATE = FanControl_B.Compare;
  if (FanControl_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update for UnitDelay: '<S17>/Output' */
    FanControl_DW.Output_DSTATE = FanControl_B.FixPtSwitch;
  }

  if (FanControl_M->Timing.TaskCounters.TID[3] == 0) {
    /* Update for DiscreteZeroPole: '<S15>/Discrete Zero-Pole' */
    {
      FanControl_DW.DiscreteZeroPole_DSTATE_e = FanControl_B.IntegralGain_d +
        FanControl_P.DiscreteZeroPole_A_n*
        FanControl_DW.DiscreteZeroPole_DSTATE_e;
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   */
  FanControl_M->Timing.t[0] =
    (++FanControl_M->Timing.clockTick0) * FanControl_M->Timing.stepSize0;

  {
    /* Update absolute timer for sample time: [0.0001s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The resolution of this integer timer is 0.0001, which is the step size
     * of the task. Size of "clockTick1" ensures timer will not overflow during the
     * application lifespan selected.
     */
    FanControl_M->Timing.clockTick1++;
  }

  rate_scheduler();
}

/* Model initialize function */
void FanControl_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)FanControl_M, 0,
                sizeof(RT_MODEL_FanControl_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&FanControl_M->solverInfo,
                          &FanControl_M->Timing.simTimeStep);
    rtsiSetTPtr(&FanControl_M->solverInfo, &rtmGetTPtr(FanControl_M));
    rtsiSetStepSizePtr(&FanControl_M->solverInfo,
                       &FanControl_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&FanControl_M->solverInfo, ((const char_T **)
      (&rtmGetErrorStatus(FanControl_M))));
    rtsiSetRTModelPtr(&FanControl_M->solverInfo, FanControl_M);
  }

  rtsiSetSimTimeStep(&FanControl_M->solverInfo, MAJOR_TIME_STEP);
  rtsiSetSolverName(&FanControl_M->solverInfo,"FixedStepDiscrete");
  rtmSetTPtr(FanControl_M, &FanControl_M->Timing.tArray[0]);
  FanControl_M->Timing.stepSize0 = 0.0001;

  /* block I/O */
  (void) memset(((void *) &FanControl_B), 0,
                sizeof(B_FanControl_T));

  /* states (dwork) */
  (void) memset((void *)&FanControl_DW, 0,
                sizeof(DW_FanControl_T));

  /* Start for S-Function (arduinoanaloginput_sfcn): '<Root>/Analog Input1' */
  MW_pinModeAnalogInput(FanControl_P.AnalogInput1_p1);

  /* Start for S-Function (arduinoanaloginput_sfcn): '<Root>/Analog Input' */
  MW_pinModeAnalogInput(FanControl_P.AnalogInput_p1);

  /* Start for S-Function (arduinodigitalinput_sfcn): '<S6>/Digital Input1' */
  MW_pinModeInput(FanControl_P.DigitalInput1_p1);

  /* Start for Triggered SubSystem: '<S16>/Sample and Hold' */
  /* VirtualOutportStart for Outport: '<S20>/ ' */
  FanControl_B.In = FanControl_P._Y0;

  /* End of Start for SubSystem: '<S16>/Sample and Hold' */

  /* Start for S-Function (arduinoanalogoutput_sfcn): '<S4>/PWM' */
  MW_pinModeOutput(FanControl_P.PWM_pinNumber);

  /* Start for S-Function (arduinodigitaloutput_sfcn): '<S1>/Digital Output' */
  MW_pinModeOutput(FanControl_P.DigitalOutput_pinNumber);
  FanControl_PrevZCX.SampleandHold_Trig_ZCE = POS_ZCSIG;
  FanControl_PrevZCX.MATLABFunction_Trig_ZCE = UNINITIALIZED_ZCSIG;

  /* InitializeConditions for UnitDelay: '<S8>/Unit Delay' */
  FanControl_DW.UnitDelay_DSTATE = FanControl_P.UnitDelay_InitialCondition;

  /* InitializeConditions for UnitDelay: '<S19>/Delay Input1' */
  FanControl_DW.DelayInput1_DSTATE = FanControl_P.RisingEdgeDetector_vinit;

  /* InitializeConditions for UnitDelay: '<S17>/Output' */
  FanControl_DW.Output_DSTATE = FanControl_P.Output_InitialCondition;

  /* InitializeConditions for S-Function (sdspcount2): '<S16>/Counter' */
  FanControl_DW.Counter_ClkEphState = 5UL;
  FanControl_DW.Counter_RstEphState = 5UL;
  FanControl_DW.Counter_Count = FanControl_P.Counter_InitialCount;

  /* InitializeConditions for MATLAB Function: '<S2>/MATLAB Function' */
  FanControl_DW.initflag_not_empty = false;
}

/* Model terminate function */
void FanControl_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
