/*
 * File: FanControl.h
 *
 * Code generated for Simulink model 'FanControl'.
 *
 * Model version                  : 1.113
 * Simulink Coder version         : 8.6 (R2014a) 27-Dec-2013
 * TLC version                    : 8.6 (Jan 30 2014)
 * C/C++ source code generated on : Thu Mar 26 12:50:54 2015
 *
 * Target selection: realtime.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_FanControl_h_
#define RTW_HEADER_FanControl_h_
#include <float.h>
#include <math.h>
#include <string.h>
#include <stddef.h>
#ifndef FanControl_COMMON_INCLUDES_
# define FanControl_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "arduino_analoginput_lct.h"
#include "arduino_digitalinput_lct.h"
#include "arduino_analogoutput_lct.h"
#include "arduino_serialwrite_lct.h"
#include "arduino_digitaloutput_lct.h"
#endif                                 /* FanControl_COMMON_INCLUDES_ */

#include "FanControl_types.h"
#include "rt_zcfcn.h"
#include "rt_nonfinite.h"
#include "rtGetInf.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetT
# define rtmGetT(rtm)                  (rtmGetTPtr((rtm))[0])
#endif

/* Block signals (auto storage) */
typedef struct {
  real_T IntegralGain;                 /* '<S25>/Integral Gain' */
  real_T n_stell;                      /* '<S8>/Sum4' */
  real_T DataTypeConversion;           /* '<S16>/Data Type Conversion' */
  real_T IntegralGain_d;               /* '<S15>/Integral Gain' */
  real_T DiscreteZeroPole;             /* '<S15>/Discrete Zero-Pole' */
  real_T Step;                         /* '<S2>/Step' */
  uint16_T AnalogInput1;               /* '<Root>/Analog Input1' */
  uint16_T AnalogInput;                /* '<Root>/Analog Input' */
  uint16_T Output;                     /* '<S17>/Output' */
  uint16_T FixPtSwitch;                /* '<S23>/FixPt Switch' */
  uint16_T In;                         /* '<S20>/In' */
  boolean_T Compare;                   /* '<S24>/Compare' */
  boolean_T Compare_j;                 /* '<S18>/Compare' */
} B_FanControl_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T UnitDelay_DSTATE;             /* '<S8>/Unit Delay' */
  real_T DiscreteZeroPole_DSTATE;      /* '<S25>/Discrete Zero-Pole' */
  real_T DiscreteZeroPole_DSTATE_e;    /* '<S15>/Discrete Zero-Pole' */
  uint32_T Counter_ClkEphState;        /* '<S16>/Counter' */
  uint32_T Counter_RstEphState;        /* '<S16>/Counter' */
  uint16_T Output_DSTATE;              /* '<S17>/Output' */
  uint16_T Counter_Count;              /* '<S16>/Counter' */
  boolean_T DelayInput1_DSTATE;        /* '<S19>/Delay Input1' */
  boolean_T initflag_not_empty;        /* '<S2>/MATLAB Function' */
} DW_FanControl_T;

/* Zero-crossing (trigger) state */
typedef struct {
  ZCSigState SampleandHold_Trig_ZCE;   /* '<S16>/Sample and Hold' */
  ZCSigState MATLABFunction_Trig_ZCE;  /* '<S2>/MATLAB Function' */
} PrevZCX_FanControl_T;

/* Parameters (auto storage) */
struct P_FanControl_T_ {
  real_T T;                            /* Variable: T
                                        * Referenced by:
                                        *   '<S15>/Integral Gain'
                                        *   '<S25>/Integral Gain'
                                        */
  real_T T_des;                        /* Variable: T_des
                                        * Referenced by:
                                        *   '<Root>/T_des'
                                        *   '<S8>/fanswitch'
                                        */
  real_T TempPIcontroller_I_Gain;      /* Mask Parameter: TempPIcontroller_I_Gain
                                        * Referenced by: '<S25>/Integral Gain'
                                        */
  real_T RPMPIcontroller_I_Gain;       /* Mask Parameter: RPMPIcontroller_I_Gain
                                        * Referenced by: '<S15>/Integral Gain'
                                        */
  real_T TempPIcontroller_P_Gain;      /* Mask Parameter: TempPIcontroller_P_Gain
                                        * Referenced by: '<S25>/Proportional Gain'
                                        */
  real_T RPMPIcontroller_P_Gain;       /* Mask Parameter: RPMPIcontroller_P_Gain
                                        * Referenced by: '<S15>/Proportional Gain'
                                        */
  real_T CompareToConstant_const;      /* Mask Parameter: CompareToConstant_const
                                        * Referenced by: '<S26>/Constant'
                                        */
  real_T CompareToConstant1_const;     /* Mask Parameter: CompareToConstant1_const
                                        * Referenced by: '<S27>/Constant'
                                        */
  uint32_T PWM_pinNumber;              /* Mask Parameter: PWM_pinNumber
                                        * Referenced by: '<S4>/PWM'
                                        */
  uint32_T DigitalOutput_pinNumber;    /* Mask Parameter: DigitalOutput_pinNumber
                                        * Referenced by: '<S1>/Digital Output'
                                        */
  uint32_T SerialTransmit_portNumber;  /* Mask Parameter: SerialTransmit_portNumber
                                        * Referenced by: '<S7>/Serial Transmit'
                                        */
  uint16_T Counter_InitialCount;       /* Mask Parameter: Counter_InitialCount
                                        * Referenced by: '<S16>/Counter'
                                        */
  uint16_T ResetValue_const;           /* Mask Parameter: ResetValue_const
                                        * Referenced by: '<S18>/Constant'
                                        */
  uint16_T SampleandHoldValue_const;   /* Mask Parameter: SampleandHoldValue_const
                                        * Referenced by: '<S21>/Constant'
                                        */
  uint16_T CounterLimitedLimit500_uplimit;/* Mask Parameter: CounterLimitedLimit500_uplimit
                                           * Referenced by: '<S23>/FixPt Switch'
                                           */
  uint8_T MATLABFunction_gPin;         /* Mask Parameter: MATLABFunction_gPin
                                        * Referenced by: '<S2>/MATLAB Function'
                                        */
  uint8_T MATLABFunction_rckPin;       /* Mask Parameter: MATLABFunction_rckPin
                                        * Referenced by: '<S2>/MATLAB Function'
                                        */
  uint8_T MATLABFunction_sckPin;       /* Mask Parameter: MATLABFunction_sckPin
                                        * Referenced by: '<S2>/MATLAB Function'
                                        */
  uint8_T MATLABFunction_serPin;       /* Mask Parameter: MATLABFunction_serPin
                                        * Referenced by: '<S2>/MATLAB Function'
                                        */
  boolean_T RisingEdgeDetector_vinit;  /* Mask Parameter: RisingEdgeDetector_vinit
                                        * Referenced by: '<S19>/Delay Input1'
                                        */
  real_T intswitch_Value;              /* Expression: 0
                                        * Referenced by: '<S25>/intswitch'
                                        */
  real_T UnitDelay_InitialCondition;   /* Expression: 0
                                        * Referenced by: '<S8>/Unit Delay'
                                        */
  real_T DiscreteZeroPole_A;           /* Computed Parameter: DiscreteZeroPole_A
                                        * Referenced by: '<S25>/Discrete Zero-Pole'
                                        */
  real_T DiscreteZeroPole_C;           /* Computed Parameter: DiscreteZeroPole_C
                                        * Referenced by: '<S25>/Discrete Zero-Pole'
                                        */
  real_T DiscreteZeroPole_D;           /* Computed Parameter: DiscreteZeroPole_D
                                        * Referenced by: '<S25>/Discrete Zero-Pole'
                                        */
  real_T Gain2_Gain;                   /* Expression: 1240
                                        * Referenced by: '<S8>/Gain2'
                                        */
  real_T Saturation_UpperSat;          /* Expression: 6200
                                        * Referenced by: '<S8>/Saturation'
                                        */
  real_T Saturation_LowerSat;          /* Expression: 0
                                        * Referenced by: '<S8>/Saturation'
                                        */
  real_T n_offset_Value;               /* Expression: 600
                                        * Referenced by: '<S8>/n_offset'
                                        */
  real_T DiscreteZeroPole_A_n;         /* Computed Parameter: DiscreteZeroPole_A_n
                                        * Referenced by: '<S15>/Discrete Zero-Pole'
                                        */
  real_T DiscreteZeroPole_C_a;         /* Computed Parameter: DiscreteZeroPole_C_a
                                        * Referenced by: '<S15>/Discrete Zero-Pole'
                                        */
  real_T DiscreteZeroPole_D_l;         /* Computed Parameter: DiscreteZeroPole_D_l
                                        * Referenced by: '<S15>/Discrete Zero-Pole'
                                        */
  real_T Gain_Gain;                    /* Expression: 1/20
                                        * Referenced by: '<S14>/Gain'
                                        */
  real_T Saturation_UpperSat_h;        /* Expression: 255
                                        * Referenced by: '<S14>/Saturation'
                                        */
  real_T Saturation_LowerSat_f;        /* Expression: 0
                                        * Referenced by: '<S14>/Saturation'
                                        */
  real_T SOF1_Value;                   /* Expression: 32
                                        * Referenced by: '<S7>/SOF1'
                                        */
  real_T SOF2_Value;                   /* Expression: 130
                                        * Referenced by: '<S7>/SOF2'
                                        */
  real_T Constant_Value;               /* Expression: 256
                                        * Referenced by: '<S7>/Constant'
                                        */
  real_T EOF1_Value;                   /* Expression: 233
                                        * Referenced by: '<S7>/EOF1'
                                        */
  real_T EOF2_Value;                   /* Expression: 210
                                        * Referenced by: '<S7>/EOF2'
                                        */
  real_T Heating_status_Value;         /* Expression: 1
                                        * Referenced by: '<Root>/Heating_status'
                                        */
  real_T Step_Time;                    /* Expression: 1
                                        * Referenced by: '<S2>/Step'
                                        */
  real_T Step_Y0;                      /* Expression: 0
                                        * Referenced by: '<S2>/Step'
                                        */
  real_T Step_YFinal;                  /* Expression: 1
                                        * Referenced by: '<S2>/Step'
                                        */
  uint32_T AnalogInput1_p1;            /* Computed Parameter: AnalogInput1_p1
                                        * Referenced by: '<Root>/Analog Input1'
                                        */
  uint32_T AnalogInput_p1;             /* Computed Parameter: AnalogInput_p1
                                        * Referenced by: '<Root>/Analog Input'
                                        */
  uint32_T DigitalInput1_p1;           /* Computed Parameter: DigitalInput1_p1
                                        * Referenced by: '<S6>/Digital Input1'
                                        */
  uint16_T Constant_Value_b;           /* Computed Parameter: Constant_Value_b
                                        * Referenced by: '<S23>/Constant'
                                        */
  uint16_T _Y0;                        /* Computed Parameter: _Y0
                                        * Referenced by: '<S20>/ '
                                        */
  uint16_T Switch2_Threshold;          /* Computed Parameter: Switch2_Threshold
                                        * Referenced by: '<S8>/Switch2'
                                        */
  uint16_T Output_InitialCondition;    /* Computed Parameter: Output_InitialCondition
                                        * Referenced by: '<S17>/Output'
                                        */
  uint16_T FixPtConstant_Value;        /* Computed Parameter: FixPtConstant_Value
                                        * Referenced by: '<S22>/FixPt Constant'
                                        */
  uint16_T Gain_Gain_n;                /* Computed Parameter: Gain_Gain_n
                                        * Referenced by: '<S16>/Gain'
                                        */
  uint8_T Constant_Value_o;            /* Computed Parameter: Constant_Value_o
                                        * Referenced by: '<S9>/Constant'
                                        */
  uint8_T Constant_Value_p;            /* Computed Parameter: Constant_Value_p
                                        * Referenced by: '<S2>/Constant'
                                        */
  uint8_T Constant1_Value;             /* Computed Parameter: Constant1_Value
                                        * Referenced by: '<S9>/Constant1'
                                        */
  uint8_T Constant1_Value_i;           /* Computed Parameter: Constant1_Value_i
                                        * Referenced by: '<S2>/Constant1'
                                        */
  uint8_T Constant2_Value;             /* Computed Parameter: Constant2_Value
                                        * Referenced by: '<S9>/Constant2'
                                        */
  uint8_T Constant2_Value_c;           /* Computed Parameter: Constant2_Value_c
                                        * Referenced by: '<S2>/Constant2'
                                        */
  uint8_T Constant3_Value;             /* Computed Parameter: Constant3_Value
                                        * Referenced by: '<S9>/Constant3'
                                        */
  uint8_T Constant3_Value_d;           /* Computed Parameter: Constant3_Value_d
                                        * Referenced by: '<S2>/Constant3'
                                        */
  uint8_T Constant4_Value;             /* Computed Parameter: Constant4_Value
                                        * Referenced by: '<S9>/Constant4'
                                        */
  uint8_T Constant4_Value_n;           /* Computed Parameter: Constant4_Value_n
                                        * Referenced by: '<S2>/Constant4'
                                        */
  uint8_T Constant5_Value;             /* Computed Parameter: Constant5_Value
                                        * Referenced by: '<S9>/Constant5'
                                        */
  uint8_T Constant5_Value_f;           /* Computed Parameter: Constant5_Value_f
                                        * Referenced by: '<S2>/Constant5'
                                        */
  uint8_T Constant6_Value;             /* Computed Parameter: Constant6_Value
                                        * Referenced by: '<S9>/Constant6'
                                        */
  uint8_T Constant6_Value_k;           /* Computed Parameter: Constant6_Value_k
                                        * Referenced by: '<S2>/Constant6'
                                        */
  uint8_T Constant7_Value;             /* Computed Parameter: Constant7_Value
                                        * Referenced by: '<S9>/Constant7'
                                        */
  uint8_T Constant7_Value_i;           /* Computed Parameter: Constant7_Value_i
                                        * Referenced by: '<S2>/Constant7'
                                        */
  boolean_T Constant_Value_h;          /* Computed Parameter: Constant_Value_h
                                        * Referenced by: '<S24>/Constant'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_FanControl_T {
  const char_T * volatile errorStatus;
  RTWSolverInfo solverInfo;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    uint32_T clockTick0;
    time_T stepSize0;
    uint32_T clockTick1;
    struct {
      uint16_T TID[6];
    } TaskCounters;

    SimTimeStep simTimeStep;
    time_T *t;
    time_T tArray[6];
  } Timing;
};

/* Block parameters (auto storage) */
extern P_FanControl_T FanControl_P;

/* Block signals (auto storage) */
extern B_FanControl_T FanControl_B;

/* Block states (auto storage) */
extern DW_FanControl_T FanControl_DW;

/* Model entry point functions */
extern void FanControl_initialize(void);
extern void FanControl_output(void);
extern void FanControl_update(void);
extern void FanControl_terminate(void);

/* Real-time Model object */
extern RT_MODEL_FanControl_T *const FanControl_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'FanControl'
 * '<S1>'   : 'FanControl/Digital Output'
 * '<S2>'   : 'FanControl/Fan Settings'
 * '<S3>'   : 'FanControl/Other Functions'
 * '<S4>'   : 'FanControl/PWM1'
 * '<S5>'   : 'FanControl/PWM2'
 * '<S6>'   : 'FanControl/RPM regulation'
 * '<S7>'   : 'FanControl/Serial Interface'
 * '<S8>'   : 'FanControl/Temperature regulation'
 * '<S9>'   : 'FanControl/Fan Settings/Data_Shiftregister'
 * '<S10>'  : 'FanControl/Fan Settings/MATLAB Function'
 * '<S11>'  : 'FanControl/Other Functions/DutyCycle Conversion'
 * '<S12>'  : 'FanControl/Other Functions/Subsystem'
 * '<S13>'  : 'FanControl/Other Functions/Vorsteuerung'
 * '<S14>'  : 'FanControl/RPM regulation/RPM DutyCycle Conversion'
 * '<S15>'  : 'FanControl/RPM regulation/RPM PI controller'
 * '<S16>'  : 'FanControl/RPM regulation/RPM Sensor'
 * '<S17>'  : 'FanControl/RPM regulation/RPM Sensor/Counter Limited (Limit: 500)'
 * '<S18>'  : 'FanControl/RPM regulation/RPM Sensor/Reset Value'
 * '<S19>'  : 'FanControl/RPM regulation/RPM Sensor/Rising Edge Detector'
 * '<S20>'  : 'FanControl/RPM regulation/RPM Sensor/Sample and Hold'
 * '<S21>'  : 'FanControl/RPM regulation/RPM Sensor/Sample and Hold Value'
 * '<S22>'  : 'FanControl/RPM regulation/RPM Sensor/Counter Limited (Limit: 500)/Increment Real World'
 * '<S23>'  : 'FanControl/RPM regulation/RPM Sensor/Counter Limited (Limit: 500)/Wrap To Zero'
 * '<S24>'  : 'FanControl/RPM regulation/RPM Sensor/Rising Edge Detector/Positive'
 * '<S25>'  : 'FanControl/Temperature regulation/Temp PI controller'
 * '<S26>'  : 'FanControl/Temperature regulation/Temp PI controller/Compare To Constant'
 * '<S27>'  : 'FanControl/Temperature regulation/Temp PI controller/Compare To Constant1'
 */
#endif                                 /* RTW_HEADER_FanControl_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
