function [dataIntegrity, packet] = ReceivePacket(serialObject)

packetLength = 8;
packetByteArray = zeros(1, packetLength);

% process the contents
for i = 1 : 1 : packetLength
    packetByteArray(i) = uint8(fread(serialObject, 1, 'uint8'));
end

% Note: the packet structure is as follows:
% start indicator
% RPM fan
% T ambient
% T wind tunnel
% stop indicator

% check, whether data integrity is guaranteed
packetStartDelimiter = 256 * packetByteArray(1) + packetByteArray(2);
packetEndDelimiter = 256 * packetByteArray(packetLength-1) + packetByteArray(packetLength);

dataIntegrityTemp = false;

if packetStartDelimiter == 8322
    dataIntegrityTemp = true;
end
if dataIntegrityTemp == true
    if packetEndDelimiter == 59858
    else
        dataIntegrityTemp = false;
    end
end

dataIntegrity = dataIntegrityTemp;

% check on data integrity
if dataIntegrityTemp == true
    % since the packet contains proper data, process each individual
    % information
    packet.rpmFan = 256 * packetByteArray(5) + packetByteArray(6);
    packet.tAmbient = double(packetByteArray(3)) * 4.88 / 10;
    packet.tWindTunnel = double(packetByteArray(4)) * 4.88 / 10;
else
    packet = 0;
end
end